var nowjs = require('now');
var Db = require('mongodb').Db;
var Connection = require('mongodb').Connection;
var Server = require('mongodb').Server;

var server
exports.initialize = function (theServer) {
	server = theServer
	var everyone = nowjs.initialize(server, {socketio:{"log level": process.argv[2]}});
	
	module.exports = everyone.now;
	
	var usercoll;
	var mediacoll;
	var db = new Db('djs', new Server("localhost", 27017, {}), {native_parser:false});
	db.open(function(err, conn) {
		db = conn;
		db.collection('userinfo', function(err, coll) {
			usercoll = coll;
		});
		db.collection('mediainfo', function(err, coll) {
			mediacoll = coll;
		});
	});
	
	everyone.now.SbroadcastMedia = function (mId, roomId) {
		var self = this
		//usercoll.findOne({isKing: true}, function (err, doc) {
		//	if (doc.uId == self.user.clientId) {
			if (roomId != undefined) {
				mediacoll.findOne({_id: new db.bson_serializer.ObjectID(mId)}, function (err, doc) {
					var room = nowjs.getGroup(roomId);
					room.now.playback(doc);
					//callback(doc)
					console.log(doc.metadata.t)
				});
			} else {
				mediacoll.findOne({_id: new db.bson_serializer.ObjectID(mId)}, function (err, doc) {
					console.log(doc)
					everyone.now.playback(doc);
					console.log(doc.metadata.t)
					//callback(doc);
				});
			}
		//	}
		//});
	}
	
	everyone.now.SgetCurrentMedia = function () {
		
	}
	
	everyone.now.SfindMedia = function (searchQuery, callback) {
		searchQuery = ("" + searchQuery).toLowerCase();
		var self = this;
		if (searchQuery === "") {
			var cursor = mediacoll.find({});
		 	cursor.toArray(function(err, array) {
				callback(array);
			});
		} else {
			var cursor = mediacoll.find({tags: searchQuery});
			cursor.toArray(function(err, array) {
				callback(array);
			});
		}
	}
	
	everyone.now.SaddMedia = function (path, tags, metadata) {
		
		mediacoll.insert(
			{
				path: path,
				tags: tags,
				metadata: metadata
			});
	}
	
	
	everyone.now.SaddToRoom = function (roomId) {
		var self = this;
		var group = nowjs.getGroup(roomId);
		group.addUser(self.user.clientId);
		
	}
	
	everyone.now.SleaveRoom = function (roomId) {
		var self = this;
		this.getGroups(function (groups) {
			if (roomId) {
				for (var i = groups.length; i--;) {
					if (groups[i] == roomId) {
						nowjs.getGroup(groups[i]).removeUser(self.user.clientId);
					}
				}
			} else {
				for (var i = groups.length; i--;) {
					nowjs.getGroup(groups[i]).removeUser(self.user.clientId);
				}
			}
		});
	}

	//groups prototypes
	everyone.now.SaddUser = function (uId) {
		var self = this;
		
		usercoll.insert(
			{
				uId: uId,
				groups: [ ] 
			});
	}
	
	everyone.now.SremoveUser = function (uId) {
		var self = this;
		
		usercoll.remove(
			{
				uId: uId
			});
	}
	
	everyone.now.SloginUser = function (uId) {
		var self = this;
		
		usercoll.findOne({uId: uId}, function (err,doc) {
			for( var i in doc.groups){
				nowjs.getGroup(doc.groups[i]).addUser(self.user.clientId)
			}
		});
	}
	
	everyone.now.SlogoutUser = function (uId) {
		var self = this;
		usercoll.findOne({uId: uId}, function (err,doc) {
			for( var i in doc.groups){
				nowjs.getGroup(doc.groups[i]).removeUser(self.user.clientId)
			}
		});
	}
	
	everyone.now.subscribeToGroup = function (uId, groupId) {
		var self = this;
		usercoll.findOne({uId: uId}, function (err,doc) {
			newdoc = doc.groups.push(groupId);
			usercoll.update({groups: newdoc}, doc, function (err, doc){
				nowjs.getGroup(groupId).addUser(self.user.clientId);
			});
		});
		
	}
		
	everyone.now.unsubscribeFromGroup = function (uId, groupId){
		var self = this;
		
		usercoll.findOne({uId: uId}, function (err,doc) {
			var i = 0;
			while( doc.groups[i] != groupId && i < doc.groups.length ){
				if (i == doc.groups.length-1){
					//you were not in the group
					return;
				}
				i = i + 1;
			}
			
			
			
			newdoc = doc.groups.splice(i,1);
			
			usercoll.update({groups: newdoc}, doc, function (err, doc){
				nowjs.getGroup(groupId).removeUser(self.user.clientId);
			});
		});
	}
	
	everyone.now.unsubscribeFromGroup = function (uId, groupId){
		var self = this;
		
		usercoll.findOne({uId: uId}, function (err,doc) {
			var i = 0;
			while( doc.groups[i] != groupId && i < doc.groups.length ){
				if (i == doc.groups.length-1){
					//you were not in the group
					return;
				}
				i = i + 1;
			}
			
			
			
			newdoc = doc.groups.splice(i,1);
			
			usercoll.update({groups: newdoc}, doc, function (err, doc){
				nowjs.getGroup(groupId).removeUser(self.user.clientId);
			});
		})
	}
}
